﻿/*
 *         Progetto: Errore dovuto all'interleaving
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 3/12/2018
 *  
 */

using System;
using System.Threading.Tasks;

namespace InterleavingErrato
{
    class InterleavingErrato
    {
        const int MAX_ITERAZIONI = 100000;
        static int N;
        static void Main(string[] args)
        {
            Console.WriteLine("ACCESSO LIBERO");
            N = 0;
            Parallel.Invoke(Incrementa, Decrementa);
            Console.WriteLine("N = {0}", N);
        }

        static void Incrementa()
        {
            int i, temp;

            i = 0;
            while (i < MAX_ITERAZIONI)
            {
                // Inizio della sezione critica (accesso libero alla variabile N)
                temp = N;
                temp = temp + 1;
                N = temp;
                // Fine della sezione critica

                i++;
            }
        }

        static void Decrementa()
        {
            int i, temp;

            i = 0;
            while (i < MAX_ITERAZIONI)
            {
                // Inizio della sezione critica (accesso libero alla variabile N)
                temp = N;
                temp = temp - 1;
                N = temp;
                // Fine della sezione critica

                i++;
            }
        }
    }
}
